package implement

import (
	"code.fnuoos.com/EggPlanet/egg_models.git/src/dao"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	zhios_order_relate_utils "code.fnuoos.com/EggPlanet/egg_models.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_models.git/utils/logx"
	"xorm.io/xorm"
)

func NewArticleCateDb(engine *xorm.Engine) dao.ArticleCateDao {
	return &ArticleCateDb{Db: engine}
}

type ArticleCateDb struct {
	Db *xorm.Engine
}

func (a ArticleCateDb) GetArticleCate(id string) (m *model.ArticleCate, err error) {
	m = new(model.ArticleCate)
	has, err := a.Db.Where("id=?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
func (a ArticleCateDb) ArticleCateByPid(pid string) (*[]model.ArticleCate, error) {
	var m []model.ArticleCate
	if err := a.Db.Where("pid=?", pid).Find(&m); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}
func (a ArticleCateDb) FindArticleCate(page, limit, pid string) (*[]model.ArticleCate, error) {
	var m []model.ArticleCate
	sess := a.Db.Where("is_show=1")
	start := (zhios_order_relate_utils.StrToInt(page) - 1) * zhios_order_relate_utils.StrToInt(limit)
	if pid != "" {
		sess.And("pid=?", pid)
	}
	err := sess.Limit(zhios_order_relate_utils.StrToInt(limit), start).OrderBy("sort desc,id desc").Find(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}
func (a ArticleCateDb) FindArticleCateAndTotal(page, limit, pid string) (*[]model.ArticleCate, int64, error) {
	var m []model.ArticleCate
	sess := a.Db.Where("1=1")
	start := (zhios_order_relate_utils.StrToInt(page) - 1) * zhios_order_relate_utils.StrToInt(limit)
	if pid != "" {
		sess.And("pid=?", pid)
	}
	count, err := sess.Limit(zhios_order_relate_utils.StrToInt(limit), start).OrderBy("sort desc,id desc").FindAndCount(&m)
	if err != nil {
		return nil, count, zhios_order_relate_logx.Error(err)
	}
	return &m, count, nil
}
func (a ArticleCateDb) FindArticleCateAndTotalPid(page, limit string) (*[]model.ArticleCate, int64, error) {
	var m []model.ArticleCate
	sess := a.Db.Where("pid>0")
	start := (zhios_order_relate_utils.StrToInt(page) - 1) * zhios_order_relate_utils.StrToInt(limit)
	count, err := sess.Limit(zhios_order_relate_utils.StrToInt(limit), start).OrderBy("sort desc,id desc").FindAndCount(&m)
	if err != nil {
		return nil, count, zhios_order_relate_logx.Error(err)
	}
	return &m, count, nil
}
